Bug 127010

Summary: [CSS Shapes] Basic shapes' computed position should be a horizontal and vertical offset
Product: WebKit Reporter: Bear Travis <betravis>
Component: CSSAssignee: Bear Travis <betravis>
Status: RESOLVED FIXED    
Severity: Normal CC: buildbot, commit-queue, dino, dstockwell, esprehn+autocc, glenn, gyuyoung.kim, kondapallykalyan, macpherson, menard, rniwa, simon.fraser
Priority: P2    
Version: 528+ (Nightly build)   
Hardware: Unspecified   
OS: Unspecified   
Bug Depends on:    
Bug Blocks: 124173    
Attachments:
Description Flags
Initial Patch
none
Fixing Changelog
rwlbuis: review+, buildbot: commit-queue-
Renaming Direction Types
buildbot: commit-queue-
Fixing up unused params none

Description Bear Travis 2014-01-14 14:07:45 PST
The computed values for basic shape positions should be a horizontal (left) and vertical (top) offset. Bottom, right, and center coordinates can be converted to these based on a percentage (50% or 100%) and their original offsets.

This initial work will transition over to a calc value for blending, but use the original format for blending, omitting values where possible when serializing.
Comment 1 Bear Travis 2014-01-14 14:31:32 PST
Created attachment 221203 [details]
Initial Patch
Comment 2 WebKit Commit Bot 2014-01-14 14:33:44 PST
Attachment 221203 [details] did not pass style-queue:

Failed to run "['Tools/Scripts/check-webkit-style', '--diff-files', u'LayoutTests/ChangeLog', u'LayoutTests/animations/resources/animation-test-helpers.js', u'LayoutTests/fast/shapes/parsing/parsing-shape-inside-expected.txt', u'LayoutTests/fast/shapes/parsing/parsing-shape-outside-expected.txt', u'LayoutTests/fast/shapes/parsing/parsing-test-utils.js', u'LayoutTests/fast/shapes/shape-outside-floats/shape-outside-animation-expected.txt', u'LayoutTests/fast/shapes/shape-outside-floats/shape-outside-animation.html', u'Source/WebCore/ChangeLog', u'Source/WebCore/css/BasicShapeFunctions.cpp', u'Source/WebCore/page/animation/CSSPropertyAnimation.cpp', u'Source/WebCore/rendering/style/BasicShapes.cpp', u'Source/WebCore/rendering/style/BasicShapes.h', '--commit-queue']" exit_code: 1
ERROR: LayoutTests/ChangeLog:8:  Line contains tab character.  [whitespace/tab] [5]
Total errors found: 1 in 12 files


If any of these errors are false positives, please file a bug against check-webkit-style.
Comment 3 Bear Travis 2014-01-14 14:39:29 PST
Created attachment 221205 [details]
Fixing Changelog
Comment 4 Build Bot 2014-01-14 20:13:50 PST
Comment on attachment 221205 [details]
Fixing Changelog

Attachment 221205 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.appspot.com/results/5156392377778176
Comment 5 Build Bot 2014-01-14 21:12:11 PST
Comment on attachment 221205 [details]
Fixing Changelog

Attachment 221205 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.appspot.com/results/5076589335281664
Comment 6 Rob Buis 2014-01-15 07:00:42 PST
Comment on attachment 221205 [details]
Fixing Changelog

View in context: https://bugs.webkit.org/attachment.cgi?id=221205&action=review

Looks good overall, glad to see RenderBox params go. As you see I just have some questions left.

> Source/WebCore/rendering/style/BasicShapes.h:128
> +        Flipped

I am not sure that is the best naming. Why would top/left be the default? Maybe "Normal" is better?

> LayoutTests/fast/shapes/shape-outside-floats/shape-outside-animation-expected.txt:26
> +PASS - "webkitShapeOutside" property for "circle-to-bottomright-extended-using-keyword-2-box" element at 1s saw something close to: circle(35% at calc((50% * 0.5) + ((100% - 10%) * 0.5)) calc((50% * 0.5) + ((100% - 10px) * 0.5)))

The calc() stuff takes some getting used to :)
How does calc() know what box (border/content/etc) to apply the calculations to?
Comment 7 Rob Buis 2014-01-16 07:23:38 PST
Comment on attachment 221205 [details]
Fixing Changelog

astearns pointed out on irc that my reference box calculation comment is invalid. That only leaves the naming, which I encourage you to have a look at before landing.
Comment 8 Bear Travis 2014-01-16 12:07:30 PST
Created attachment 221398 [details]
Renaming Direction Types

Renamed to TopLeft and BottomRight.
Comment 9 Build Bot 2014-01-16 12:33:18 PST
Comment on attachment 221398 [details]
Renaming Direction Types

Attachment 221398 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.appspot.com/results/5298898050482176
Comment 10 Build Bot 2014-01-16 12:58:44 PST
Comment on attachment 221398 [details]
Renaming Direction Types

Attachment 221398 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.appspot.com/results/4767758436794368
Comment 11 Bear Travis 2014-01-16 17:13:53 PST
Created attachment 221430 [details]
Fixing up unused params
Comment 12 WebKit Commit Bot 2014-01-17 12:09:18 PST
Comment on attachment 221430 [details]
Fixing up unused params

Clearing flags on attachment: 221430

Committed r162210: <http://trac.webkit.org/changeset/162210>
Comment 13 WebKit Commit Bot 2014-01-17 12:09:22 PST
All reviewed patches have been landed.  Closing bug.